#!/bin/tcsh -f

#  bscg - an experimental binary-based static call graph generator
#         using libbfd, libopcodes and DWARF2-XML.
#  Copyright (C) 2003, by gondow@cs.titech.ac.jp, All rights reserved.
#  $Id: bscg.csh,v 1.2 2003/10/29 11:31:21 gondow Exp gondow $

mkdir -p HTML

set DOT_FILE   = $1
set MAIN_HTML  = HTML/$1:r-main.html
set GRAPH_HTML = HTML/$1:r-graph.html
set GIF_FILE   = HTML/$1:r.gif
set CMAP_FILE  = HTML/$1:r.cmap
set SVG_FILE   = HTML/$1:r.svg

cp $DOT_FILE HTML
dot -Tgif  $DOT_FILE > $GIF_FILE
dot -Tcmap $DOT_FILE > $CMAP_FILE
dot -Tsvg  $DOT_FILE > $SVG_FILE

cat > $MAIN_HTML <<EOF
<html>
<frameset cols="60%, *">
    <frame src="$GRAPH_HTML:t" name="gif">
    <frame src="" name="src">
</frameset>
</html>
EOF

cat > $GRAPH_HTML <<EOF
<html><body>
<img src="$GIF_FILE:t" alt="$GIF_FILE:t" usemap="#map"/>
<map name="map">
EOF

cat >> $GRAPH_HTML < $CMAP_FILE

cat >> $GRAPH_HTML <<EOF
</map></body></html>
EOF

ed $GRAPH_HTML >& /dev/null <<EOF
1,\$s/^<area/<area target="src"/g
w
q
EOF

#end
